'------------------------------------------------------------------------
'                          Hesari.vbs (v3.0)
'------------------------------------------------------------------------
' - Run "RunMeInBackground" -function in order to get your data updated.
'   Your antivirus-software may detect this as a malicious script, but
'   that's just because this writes a small temporary (.tmp) file into
'   your system.
'
' - Use "Add text file" -meter to view.
'
' - In TextFile Properties write down full path of your TEMP_DIR (see below) and
'   filename hesari.tmp into "Text File To Read From:" -datafield
'   (tex. c:\program files\samurize\configs\hesari.tmp)
'
'   (*) Only if NO_TEMPFILE = TRUE
'
' - You may change user variables below.
'
'                              				- Sami

Function RunMeInBackground

'------------------------------------------------------------------
'----------------------- User variables ---------------------------
'------------------------------------------------------------------
	const TEMP_DIR		= ""		' "String" - Where to save temp-file. ( tex. "C:\temp\" )
						' (leaving this empty ("") will save temp-file somewhere in the samurize-folder)
	const SHOW_TIME		= TRUE		' FALSE - Include no timestamps .. TRUE  = Include timestamps
	const NO_TEMPFILE	= FALSE		' TRUE - Returns whole thing into text %v-variable without saving tmp-file
						' FALSE - Saves everything into tmp-file
	const LINKABLE		= FALSE		' TRUE - Doubleclicking on the news item shows additional information
						' FALSE - Disable linksupport
						' !! EXPERIMENTAL !!
'------------------------------------------------------------------

	dim htmlResult,fs,f,outputti,uutinen,kello,linefeedi,linkki

	htmlResult = ReturnHTML("http://siirto.helsinginsanomat.fi/aukio/HS-Tuoreet-Top5.xml")
	outputti = ""
	linkki = ""
	kello = ""
	if NO_TEMPFILE = TRUE then
		linefeedi = "%b"
	else
		linefeedi = Chr(13) & Chr(10)
	end if

	relnext = instr(htmlResult, "uutinen id")
	if relnext > 0 then
		for i = 1 to 5
			aloitus = instr( relnext, htmlResult, "<otsikko>") + 9
			if aloitus > 9 then
				lopetus = instr( aloitus, htmlResult, "</otsikko>")
				if lopetus > aloitus then
					uutinen = mid( htmlResult, aloitus, lopetus-aloitus )
					if SHOW_TIME = TRUE then
						aloitus = instr( lopetus, htmlResult, "<pvm>") + 16
						if aloitus > 16 then
							lopetus = instr( aloitus, htmlResult, "</pvm>") - 3
							if lopetus > aloitus then
								kello = " (" & mid( htmlResult, aloitus, lopetus-aloitus ) & ")"
							else
								exit for
							end if
						else
							exit for
						end if
					end if
					if LINKABLE = TRUE then
						aloitus = instr( lopetus, htmlResult, "<url>") + 5
						if aloitus > 5 then
							lopetus = instr( aloitus, htmlResult, "</url>")
							if lopetus > aloitus then
								linkki = "%l" & mid( htmlResult, aloitus, lopetus-aloitus )
							else
								exit for
							end if
						else
							exit for
						end if
					end if

					outputti = outputti & uutinen & kello & linkki & linefeedi
					relnext = lopetus
				else
					exit for
				end if
			else
				exit for
			end if
		next
	end if
	if NO_TEMPFILE = TRUE then
		RunMeInBackground = outputti
	else
		set fs=CreateObject("Scripting.FileSystemObject")
		set f=fs.CreateTextFile(TEMP_DIR&"hesari.tmp",true)
		f.write(outputti)
		f.close
		set f=nothing
		set fs=nothing
	end if
End Function

Private Function ReturnHTML(sURL)
	Dim objXMLHTTP,HTML
	Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")
	On Error Resume Next
	objXMLHTTP.Open "GET", sURL, False
	objXMLHTTP.Send
	if err = 0 then
		HTML = objXMLHTTP.responseBody
		Set objRS = CreateObject("ADODB.Recordset")
		objRS.Fields.Append "txt", 200, 35000, &H00000080
		objRS.Open
		objRS.AddNew
		objRS.Fields("txt").AppendChunk HTML
		ReturnHTML = objRS("txt").Value
		objRS.Close
		Set objRS = Nothing
	else
		ReturnHTML = "Network error"
	end if
	On Error GoTo 0
	Set objXMLHTTP = Nothing
End Function
